SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-Morphs'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!

XpfTestCase subclass: #XpfListModelWrapperTestCase
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfListModelWrapperTestCase methodsFor: 'as yet unclassified' stamp: 'mig 2/20/2009 16:31'!
setUp
	
	sut := XpfListModelWrapper 
		on: XpfProject new
		listSelector: #userStories.
		! !

!XpfListModelWrapperTestCase methodsFor: 'as yet unclassified' stamp: 'mig 2/20/2009 16:32'!
testAccessors
	self
		checkAccessor: #selected on: sut  with: 1.
		! !

!XpfListModelWrapperTestCase methodsFor: 'as yet unclassified' stamp: 'mig 2/20/2009 16:37'!
testListPassthroug

	self should: (sut list isKindOf: Collection)! !

Object subclass: #XpfListModelWrapper
	instanceVariableNames: 'selected model listSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfListModelWrapper class methodsFor: 'instance creation' stamp: 'mig 2/20/2009 16:41'!
on: aModel listSelector: aSelector

	^ self new
		model: aModel;
		listSelector: aSelector;
		selected: 0! !

!XpfListModelWrapper methodsFor: 'as yet unclassified' stamp: 'mig 2/20/2009 16:38'!
list
	^ self model perform: self listSelector! !

!XpfListModelWrapper methodsFor: 'accessing' stamp: 'mig 2/20/2009 16:33'!
listSelector
	^ listSelector! !

!XpfListModelWrapper methodsFor: 'accessing' stamp: 'mig 2/20/2009 16:33'!
listSelector: anObject
	listSelector := anObject! !

!XpfListModelWrapper methodsFor: 'accessing' stamp: 'mig 2/20/2009 16:33'!
model
	^ model! !

!XpfListModelWrapper methodsFor: 'accessing' stamp: 'mig 2/20/2009 16:33'!
model: anObject
	model := anObject! !

!XpfListModelWrapper methodsFor: 'accessing' stamp: 'mig 2/20/2009 16:33'!
selected
	^ selected! !

!XpfListModelWrapper methodsFor: 'accessing' stamp: 'mig 2/20/2009 16:33'!
selected: anObject
	selected := anObject! !

PluggableListMorph subclass: #XpfUserStoriesListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Morphs'!

!XpfUserStoriesListMorph class methodsFor: 'instance creation' stamp: 'mig 2/20/2009 16:36'!
newForProject: anXpfProject
	| wrapper |
	wrapper := XpfListModelWrapper on: anXpfProject listSelector: #userStories. 
	^ self on: wrapper list: #list selected: #selected changeSelected: #selected:! !

TestCase subclass: #XpfClientTest
	instanceVariableNames: 'project userstory1 userstory2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Tests'!

!XpfClientTest methodsFor: 'running' stamp: 'mig 2/20/2009 15:15'!
setUp
	
	super setUp.
	project := XpfProject new.
	userstory1 := XpfUserStory new.
	userstory2 := XpfUserStory new.
	
	project
		attachUserStory: userstory1;
		attachUserStory: userstory2.! !

!XpfClientTest methodsFor: 'running' stamp: 'mig 2/20/2009 15:16'!
tearDown

	project
		detachUserStory: userstory1;
		detachUserStory: userstory1.! !

!XpfClientTest methodsFor: 'tests' stamp: 'mig 2/20/2009 16:42'!
testUserStoriesListMorph
	| sut |
	sut := XpfUserStoriesListMorph newForProject: project.
	
	self
		should: (sut isKindOf: Morph);
		should: sut getListSize = project userStories size;
		should: (sut getList includesAllOf: {userstory1 asStringOrText. userstory2 asStringOrText}).! !
